#include <SFML/Graphics.hpp>
#include "gcalc.h"
#include <iostream>
#include <sstream>

// -----------------------------------------------------------------------
template <typename T>
std::string tostr(const T& t) {
   std::ostringstream os;
   os<<t;
   return os.str();
}

void initXVals(float& xstart, float& xstop, float& xmesh) {
    std::cout << "\nEnter a starting value for x: ";
    std::cin >> xstart;
    std::cout << "\nEnter a stopping value for x: ";
    std::cin >> xstop;
    std::cout << "\nEnter the number of function values: ";
    std::cin >> xmesh;
}

std::string getFunction() {
    std::string fstr;
    std::cout << "\nEnter the function string you want to evaluate in terms of x: ";
    getline(std::cin,fstr);
    fstr += ";";
    return fstr;
}

void getFunctionValues(float* fv, std::string& fstr,
                         float& xstart, float& xstop, float& xmesh) {
    float deltaX=(xstop-xstart)/xmesh;

    std::string xstring = "let x = " + tostr(xstart) + ";";
    std::cout << std::endl << "x = " << calc(xstring);
    //std::stringstream ss(fstring); //create ss in calculator
    fv[0] = calc(fstr);
    std::cout << "\nf(" << xstart << ") = " << fv[0];
    float x = xstart;
    for(int i = 1; i <= xmesh; ++i) {
        x+=deltaX;
        xstring = "x = " + tostr(x) + ";";
        //std::cout << "\nfstring = " << fstring;
        x = calc(xstring);
        std::cout << std::endl << "x = " << x; //calc(xstring);
        //cout << "\nfstr = " << fstr;
        fv[i] = calc(fstr);
        //std::cout << "\nf(" << x << ") = " << fv[i];
    }
    //return fv;
}


int main()
{
    float xstart{0}, xstop{0}, xmesh{0};
    std::string fstr = getFunction();
    initXVals(xstart, xstop, xmesh);

    float* fvals = new float[int(xmesh)+1];
    getFunctionValues(fvals, fstr, xstart, xstop, xmesh);
    float deltaX = (xstop - xstart)/xmesh, x = xstart;
    for(int i = 0; i < xmesh+1; ++i) {
        std::cout << "\nf(" << x << ") = " << fvals[i];
        x += deltaX;
    }
    delete[] fvals;

    sf::RenderWindow window(sf::VideoMode(200, 200), "SFML works!");
    sf::CircleShape shape(100.f);
    shape.setFillColor(sf::Color::Green);
// Load a texture from a file
    sf::Texture texture;
    if (!texture.loadFromFile("jolly.png"))
        return -1;
// Assign it to a sprite
    sf::Sprite sprite;
    sprite.setTexture(texture);


//    string str;
//    float d;
//    std::cout << "\nEnter a function string and a value to evaluate it at: ";
//    std::cin >> str >> d;
//    std::cout << "\nThe value of f(" << d << ") = " << calc(str,d);

// Draw the textured sprite
    {
        sf::Event event;
        while (window.pollEvent(event))
        {
            if (event.type == sf::Event::Closed)
                window.close();
        }

        window.clear();
        window.draw(shape);
        window.draw(sprite);
        while (window.isOpen())
            window.display();
    }

    return 0;
}
